/*******************************************************************************
 * Copyright (C) 2011  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 *******************************************************************************/

/**
 * Created by porcherg
 * Date: 22/11/11
 * Time: 17:27
 */
package org.ow2.orchestra.designer.bpmn.views.data {
import flash.events.Event;

import mx.binding.utils.ChangeWatcher;

import org.ow2.orchestra.designer.bpmn.model.data.AbstractExpressionElementModel;

import org.ow2.orchestra.designer.bpmn.model.data.ExpressionDataObjectModel;

public class ExpressionDataObjectView extends AbstractExpressionElementView {
    /**
     * The source for "event" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/dataInput.svg")]
    public var dataInputImage:Class;

    public function ExpressionDataObjectView(dataModel:ExpressionDataObjectModel) {
      super(dataModel);
      watchers.addItem(ChangeWatcher.watch(dataModel, ["dataObjectModel", "name"], this.updateText));
      watchers.addItem(ChangeWatcher.watch(dataModel, ["childNodeSelector"], this.updateText));
      this.updateText();
    }

    protected override function updateImage(event:Event = null):void {
      // Update background image (start/end/intermediate event)
      imageDataBackground.source = dataInputImage;
    }

    private function updateText(event:Event = null):void {
      if (ExpressionDataObjectModel(this.model).dataObjectModel != null) {
        this._label.text = ExpressionDataObjectModel(this.model).dataObjectModel.name;
        if (AbstractExpressionElementModel(this.model).childNodeSelector != null &&
            AbstractExpressionElementModel(this.model).childNodeSelector != "") {
          this._label.text+= "." + AbstractExpressionElementModel(this.model).childNodeSelector.substring(
                AbstractExpressionElementModel(this.model).childNodeSelector.lastIndexOf("}") + 1);
        }
      } else {
        this._label.text = "";
      }
    }
  }
}
